CLEAR
SET CLASSLIB TO wwXML ADDITIVE
SET PROCEDURE TO wwUtils ADDITIVE

DO PATH WITH "DATA"

o = CREATEOBJECT("custom")

o.AddProperty("oChild1",CREATEOBJECT("custom"))
o.AddProperty("cName","Rick Strahl")
o.oChild1.AddProperty("cTest1","Testvalue")
o.oChild1.AddProperty("nTest2",123.12)

o.AddProperty("oChild2",CREATEOBJECT("custom"))
o.oChild2.AddProperty("nNumber",1231.11211)
o.oChild2.AddProperty("cString","Test String")

? o.oChild1.cTest1
? o.oChild1.nTest2

oXML = CREATEOBJECT("wwXML")
oXML.lRecurseobjects = .T.

lcXML = oXML.ObjectToXML(o)
ShowXML (lcXML)

RETURN





*** Simple Object Export/Import Example
#IF .F.
USE wwbanners
SCATTER NAME oBanner MEMO
obanner.hits = 44.121

oXML = CREATEOBJECT("wwXML")
oXML.nCreateDataStructure=1

lcXML = oXML.ObjectToXML(oBanner)

ShowXML (lcXML)

RETURN


#ENDIF



*** This example exports a complex object into an XML string
*** then reassembles the object from the XML
*** NOTE: teh object must pre-exist in order to reassemble the
***       the code!
#IF .T.

oInv = create("wcs_Invoice")
? oInv.LoadInvoice("200")

oXML = CREATE("wwXML")
oXML.cDocRootName = "invoicedemo"
oXML.lRecurseObjects = .T.
CLEAR
lcXML = oXML.ObjectToXML(oInv,"invoice")

ShowXML( lcXML )

WAIT WINDOW "Exported Object to XML" + CHR(13) + "press any key to continue..."

oInv = .NULL.

oInv = CREATEOBJECT("wcs_invoice")
oInv.LoadInvoice()  && Empty invoice

oXML.XMLToObject(lcXML,oInv)

? "Object properties have been reassigned from XML: "

? "Company",oInv.oCustomer.Company
? "Name",oInv.oCustomer.CareOf
? "Invoice Date",oInv.oInvoice.invDate
? "Invoice Total",oInv.oInvoice.Total
? "Item 1",oInv.aLineItems[1].Descript
? "item 2",oInv.aLineItems[2].Descript

RETURN
#ENDIF

*************************************************************
DEFINE CLASS wcs_Invoice AS Custom
*************************************************************
#IF .F.
*:Help Documentation
*:Topic:
wwServer::GetProcessID

*:Description:
This class is a sample class that demonstrates aggregate
objects. This invoice class simply acts as a container for
the Customer, Invoice and Lineitem objects which are object
members of this class.

*:Remarks:
Meant as an example class for use with the wwXML demo to
demonstrate hierarchical XML output.

*:ENDHELP
#ENDIF
*********************************************************************

*** Custom Properties
oInvoice = .NULL.
oCustomer = .NULL.
DIMENSION aLineItems[1] 
nLineItems = 0


*********************************************************************
FUNCTION LoadInvoice(lcInvNo)
*****************************
#IF .F.
*:Help Documentation
*:Topic:
cInvoice::LoadInvoice

*:Description:
Loads an invoice into this object by loading the various records 
from the database into the object members of the object.

*:Parameters:
lcId
The Invoice Id to load

*:Returns:
.T. or .F.

*:ENDHELP
#ENDIF
*********************************************************************
LOCAL x

*** Load an 'Empty object' with all objects
*** prefilled
IF EMPTY(lcInvNo) 
   SELECT * FROM TT_INV where .F. INTO CURSOR TQuery
   SCATTER NAME THIS.oInvoice BLANK MEMO
   
   SELECT * FROM TT_cust where .F. INTO CURSOR TQuery
   SCATTER NAME THIS.oCustomer BLANK MEMO
   
   DIMENSION THIS.aLineItems[1]
   SELECT * FROM Timebill where .F. INTO CURSOR TQuery
   SCATTER NAME THIS.aLineItems[1] BLANK MEMO
         
   RETURN
ENDIF

lcInvNo = PADL(lcInvNo,8)

*** Start with the Invoice object
SELECT * from tt_inv ;
   WHERE invno = lcInvNo ;
   INTO CURSOR TQuery

IF _TALLY < 1
   THIS.oInvoice = .NULL.
   RETURN .F.
ENDIF      
   
*** Scatter to an object
SCATTER NAME THIS.oInvoice MEMO

*** Now retrieve the lineitems
SELECT * from timebill ;
   WHERE invno = lcInvNo ;
   INTO CURSOR TQuery

IF _TALLY < 1
   THIS.oLineItems = .NULL.
ENDIF   

*** Lineitems go into an object array
THIS.nLineItems = _tally
DIMENSION THIS.aLineItems[_tally]
x=0
SCAN
   x=x+1
   SCATTER NAME THIS.aLineItems[x] MEMO
ENDSCAN

*** Finally grab the customer info
SELECT * FROM TT_cust ;
   where custno = THIS.oInvoice.custno ;
   INTO CURSOR TQuery

IF _TALLY < 1
   THIS.oCustomer = .NULL.
   RETURN .F.
ENDIF

SCATTER NAME THIS.oCustomer MEMO

RETURN .T.     
ENDFUNC
* EOF cInvoice::LoadInvoice

ENDDEFINE